simmc-agent
===========

The agent for the SIMMC - Sistema de Monitoramento do Ministério das Comunicações project.

requirements
------------
c++ compiler
cmake

building and compiling
----------------------
Run

	$ cd build
	$ cmake ..
	
to generate a `Makefile`, library objects and misterious CMake files, then

	$ make
	
to compile. The resulting executable `agent-vx.x` will be in `agent/bin`.
Run it with

	$ ./agent-vx.x

development
-----------

### submodules ###
Library cpr is a submodule forked from github's repository

[https://github.com/whoshuu/cpr](https://github.com/whoshuu/cpr)

Which contains library curl, forked from github's repository

[https://github.com/curl/curl](https://github.com/curl/curl)

Also mongoose and googletest.

To get them working, run

	$ git submodule init
	$ git submodule update --init --recursive

Any editions made to such modules must be commited inside the submodule,
to a branch of our own, and further commited in the superior module. Check
[https://git-scm.com/book/en/v2/Git-Tools-Submodules](https://git-scm.com/book/en/v2/Git-Tools-Submodules)

TODO: when packing the version for download, make sure these modules are regular directories.

### cmake fails ###
Current `CMakeLists.txt` is not mature, so if you find that building fails
at something that was already corrected, run

	$ rm -rf *

inside the `build` directory and cmake again.

### building and compiling ###
When compiling and executing the agent locally, in order to see the resulting
JSON objects, run cmake with the option `PRINT_JSON`

	$ cmake -DPRINT_JSON=ON ..

You may also set the `Debug` flag if using gdb

    $ cmake -DCMAKE_BUILD_TYPE=Debug -DPRINT_JSON=ON ..
