/* Copyright (C) 2016 Centro de Computacao Cientifica e Software Livre
 * Departamento de Informatica - Universidade Federal do Parana - C3SL/UFPR
 *
 * This file is part of simmc-agent
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301,
 * USA.
 */

#include <agent/linux/get_macaddr.h>

std::string get_macaddr() {
    std::fstream file;
    std::string macaddr;

    file.open("/sys/class/net/eth0/address", std::ifstream::in);

    if (!file.is_open()) {
        file.open("/sys/class/net/eth1/address", std::ifstream::in);
        if (!file.is_open()) {
            throw std::string("No address file found.");
        }
    }

    getline(file, macaddr);
    file.close();

    return macaddr;
}
